import { math, Marker, Component, Plugin } from 'ct-g-xeokit-viewer';
import { Dot, Wire, Label } from 'ct-g-xeokit-shared-plugin-lib';

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get() {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);
      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(arguments.length < 3 ? target : receiver);
      }

      return desc.value;
    };
  }

  return _get.apply(this, arguments);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper$2(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$2(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var originVec = math.vec3();
var targetVec = math.vec3();
/**
 * @desc Measures the angle indicated by three 3D points.
 *
 * See {@link AngleMeasurementsPlugin} for more info.
 */

var AngleMeasurement = /*#__PURE__*/function (_Component) {
  _inherits(AngleMeasurement, _Component);

  var _super = _createSuper$2(AngleMeasurement);

  /**
   * @private
   */
  function AngleMeasurement(plugin) {
    var _this;

    var cfg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, AngleMeasurement);

    _this = _super.call(this, plugin.viewer.scene, cfg);
    /**
     * The {@link AngleMeasurementsPlugin} that owns this AngleMeasurement.
     * @type {AngleMeasurementsPlugin}
     */

    _this.plugin = plugin;
    _this._container = cfg.container;

    if (!_this._container) {
      throw "config missing: container";
    }

    _this._color = cfg.color || plugin.defaultColor;
    var scene = _this.plugin.viewer.scene;
    _this._originMarker = new Marker(scene, cfg.origin);
    _this._cornerMarker = new Marker(scene, cfg.corner);
    _this._targetMarker = new Marker(scene, cfg.target);
    _this._originWorld = math.vec3();
    _this._cornerWorld = math.vec3();
    _this._targetWorld = math.vec3();
    _this._wp = new Float64Array(12);
    _this._vp = new Float64Array(12);
    _this._pp = new Float64Array(12);
    _this._cp = new Int16Array(6);
    var onMouseOver = cfg.onMouseOver ? function (event) {
      cfg.onMouseOver(event, _assertThisInitialized(_this));
    } : null;
    var onMouseLeave = cfg.onMouseLeave ? function (event) {
      cfg.onMouseLeave(event, _assertThisInitialized(_this));
    } : null;
    var onContextMenu = cfg.onContextMenu ? function (event) {
      cfg.onContextMenu(event, _assertThisInitialized(_this));
    } : null;
    _this._originDot = new Dot(_this._container, {
      fillColor: _this._color,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 2 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._cornerDot = new Dot(_this._container, {
      fillColor: _this._color,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 2 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._targetDot = new Dot(_this._container, {
      fillColor: _this._color,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 2 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._originWire = new Wire(_this._container, {
      color: _this._color || "blue",
      thickness: 1,
      zIndex: plugin.zIndex,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._targetWire = new Wire(_this._container, {
      color: _this._color || "red",
      thickness: 1,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._angleLabel = new Label(_this._container, {
      fillColor: _this._color || "#00BBFF",
      prefix: "",
      text: "",
      zIndex: plugin.zIndex + 2,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._wpDirty = false;
    _this._vpDirty = false;
    _this._cpDirty = false;
    _this._visible = false;
    _this._originVisible = false;
    _this._cornerVisible = false;
    _this._targetVisible = false;
    _this._originWireVisible = false;
    _this._targetWireVisible = false;
    _this._angleVisible = false;
    _this._labelsVisible = false;
    _this._clickable = true;

    _this._originMarker.on("worldPos", function (value) {
      _this._originWorld.set(value || [0, 0, 0]);

      _this._wpDirty = true;

      _this._needUpdate(0); // No lag

    });

    _this._cornerMarker.on("worldPos", function (value) {
      _this._cornerWorld.set(value || [0, 0, 0]);

      _this._wpDirty = true;

      _this._needUpdate(0); // No lag

    });

    _this._targetMarker.on("worldPos", function (value) {
      _this._targetWorld.set(value || [0, 0, 0]);

      _this._wpDirty = true;

      _this._needUpdate(0); // No lag

    });

    _this._onViewMatrix = scene.camera.on("viewMatrix", function () {
      _this._vpDirty = true;

      _this._needUpdate(0); // No lag

    });
    _this._onProjMatrix = scene.camera.on("projMatrix", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this._onCanvasBoundary = scene.canvas.on("boundary", function () {
      _this._cpDirty = true;

      _this._needUpdate(0); // No lag

    });
    _this.approximate = cfg.approximate;
    _this.visible = cfg.visible;
    _this.originVisible = cfg.originVisible;
    _this.cornerVisible = cfg.cornerVisible;
    _this.targetVisible = cfg.targetVisible;
    _this.originWireVisible = cfg.originWireVisible;
    _this.targetWireVisible = cfg.targetWireVisible;
    _this.angleVisible = cfg.angleVisible;
    _this.labelsVisible = cfg.labelsVisible;
    return _this;
  }

  _createClass(AngleMeasurement, [{
    key: "_update",
    value: function _update() {
      if (!this._visible) {
        return;
      }

      var scene = this.plugin.viewer.scene;

      if (this._wpDirty) {
        this._wp[0] = this._originWorld[0];
        this._wp[1] = this._originWorld[1];
        this._wp[2] = this._originWorld[2];
        this._wp[3] = 1.0;
        this._wp[4] = this._cornerWorld[0];
        this._wp[5] = this._cornerWorld[1];
        this._wp[6] = this._cornerWorld[2];
        this._wp[7] = 1.0;
        this._wp[8] = this._targetWorld[0];
        this._wp[9] = this._targetWorld[1];
        this._wp[10] = this._targetWorld[2];
        this._wp[11] = 1.0;
        this._wpDirty = false;
        this._vpDirty = true;
      }

      if (this._vpDirty) {
        math.transformPositions4(scene.camera.viewMatrix, this._wp, this._vp);
        this._vp[3] = 1.0;
        this._vp[7] = 1.0;
        this._vp[11] = 1.0;
        this._vpDirty = false;
        this._cpDirty = true;
      }

      if (this._cpDirty) {
        var near = -0.3;
        var zOrigin = this._originMarker.viewPos[2];
        var zCorner = this._cornerMarker.viewPos[2];
        var zTarget = this._targetMarker.viewPos[2];

        if (zOrigin > near || zCorner > near || zTarget > near) {
          this._originDot.setVisible(false);

          this._cornerDot.setVisible(false);

          this._targetDot.setVisible(false);

          this._originWire.setVisible(false);

          this._targetWire.setVisible(false);

          this._angleLabel.setCulled(true);

          return;
        }

        math.transformPositions4(scene.camera.project.matrix, this._vp, this._pp);
        var pp = this._pp;
        var cp = this._cp;
        var canvas = scene.canvas.canvas;
        var offsets = canvas.getBoundingClientRect();

        var containerOffsets = this._container.getBoundingClientRect();

        var top = offsets.top - containerOffsets.top;
        var left = offsets.left - containerOffsets.left;
        var aabb = scene.canvas.boundary;
        var canvasWidth = aabb[2];
        var canvasHeight = aabb[3];
        var j = 0;

        for (var i = 0, len = pp.length; i < len; i += 4) {
          cp[j] = left + Math.floor((1 + pp[i + 0] / pp[i + 3]) * canvasWidth / 2);
          cp[j + 1] = top + Math.floor((1 - pp[i + 1] / pp[i + 3]) * canvasHeight / 2);
          j += 2;
        }

        this._originDot.setPos(cp[0], cp[1]);

        this._cornerDot.setPos(cp[2], cp[3]);

        this._targetDot.setPos(cp[4], cp[5]);

        this._originWire.setStartAndEnd(cp[0], cp[1], cp[2], cp[3]);

        this._targetWire.setStartAndEnd(cp[2], cp[3], cp[4], cp[5]);

        this._angleLabel.setPosBetweenWires(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5]);

        math.subVec3(this._originWorld, this._cornerWorld, originVec);
        math.subVec3(this._targetWorld, this._cornerWorld, targetVec);
        var validVecs = (originVec[0] !== 0 || originVec[1] !== 0 || originVec[2] !== 0) && (targetVec[0] !== 0 || targetVec[1] !== 0 || targetVec[2] !== 0);

        if (validVecs) {
          math.normalizeVec3(originVec);
          math.normalizeVec3(targetVec);
          var angle = Math.abs(math.angleVec3(originVec, targetVec));
          this._angle = angle / math.DEGTORAD;

          this._angleLabel.setText(" " + this._angle.toFixed(2) + "°");
        } else {
          this._angleLabel.setText("");
        } // this._angleLabel.setText((Math.abs(math.lenVec3(math.subVec3(this._targetWorld, this._originWorld, distVec3)) * scale).toFixed(2)) + unitAbbrev);


        this._originDot.setVisible(this._visible && this._originVisible);

        this._cornerDot.setVisible(this._visible && this._cornerVisible);

        this._targetDot.setVisible(this._visible && this._targetVisible);

        this._originWire.setVisible(this._visible && this._originWireVisible);

        this._targetWire.setVisible(this._visible && this._targetWireVisible);

        this._angleLabel.setCulled(!(this._visible && this._angleVisible && this.labelsVisible));

        this._cpDirty = false;
      }
    }
    /**
     * Sets whether this AngleMeasurement indicates that its measurement is approximate.
     *
     * This is ````true```` by default.
     *
     * @type {Boolean}
     */

  }, {
    key: "approximate",
    get:
    /**
     * Gets whether this AngleMeasurement indicates that its measurement is approximate.
     *
     * This is ````true```` by default.
     *
     * @type {Boolean}
     */
    function get() {
      return this._approximate;
    }
    /**
     * Gets the origin {@link Marker}.
     *
     * @type {Marker}
     */
    ,
    set: function set(approximate) {
      approximate = approximate !== false;

      if (this._approximate === approximate) {
        return;
      }

      this._approximate = approximate;
      this._cpDirty = true;

      this._needUpdate(0);
    }
  }, {
    key: "origin",
    get: function get() {
      return this._originMarker;
    }
    /**
     * Gets the corner {@link Marker}.
     *
     * @type {Marker}
     */

  }, {
    key: "corner",
    get: function get() {
      return this._cornerMarker;
    }
    /**
     * Gets the target {@link Marker}.
     *
     * @type {Marker}
     */

  }, {
    key: "target",
    get: function get() {
      return this._targetMarker;
    }
    /**
     * Gets the angle between two connected 3D line segments, given
     * as three positions on the surface(s) of one or more {@link Entity}s.
     *
     * @type {Number}
     */

  }, {
    key: "angle",
    get: function get() {
      this._update();

      return this._angle;
    }
    /**
     * Gets the color of the angle measurement.
     *
     * The color is an HTML string representation, eg. "#00BBFF" and "blue".
     *
     * @type {String}
     */

  }, {
    key: "color",
    get: function get() {
      return this._color;
    }
    /** Sets the color of the angle measurement.
     *
     * The color is given as an HTML string representation, eg. "#00BBFF" and "blue".
     *
     * @type {String}
     */
    ,
    set: function set(value) {
      this._originDot.setFillColor(value);

      this._cornerDot.setFillColor(value);

      this._targetDot.setFillColor(value);

      this._originWire.setColor(value || "blue");

      this._targetWire.setColor(value || "red");

      this._angleLabel.setFillColor(value || "#00BBFF");

      this._color = value;
    }
    /**
     * Sets whether this AngleMeasurement is visible or not.
     *
     * @type {Boolean}
     */

  }, {
    key: "visible",
    get:
    /**
     * Gets whether this AngleMeasurement is visible or not.
     *
     * @type {Boolean}
     */
    function get() {
      return this._visible;
    }
    /**
     * Sets if the origin {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== false;
      this._visible = value;

      this._originDot.setVisible(this._visible && this._originVisible);

      this._cornerDot.setVisible(this._visible && this._cornerVisible);

      this._targetDot.setVisible(this._visible && this._targetVisible);

      this._originWire.setVisible(this._visible && this._originWireVisible);

      this._targetWire.setVisible(this._visible && this._targetWireVisible);

      this._angleLabel.setVisible(this._visible && this._angleVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "originVisible",
    get:
    /**
     * Gets if the origin {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._originVisible;
    }
    /**
     * Sets if the corner {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== false;
      this._originVisible = value;

      this._originDot.setVisible(this._visible && this._originVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "cornerVisible",
    get:
    /**
     * Gets if the corner {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._cornerVisible;
    }
    /**
     * Sets if the target {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== false;
      this._cornerVisible = value;

      this._cornerDot.setVisible(this._visible && this._cornerVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "targetVisible",
    get:
    /**
     * Gets if the target {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._targetVisible;
    }
    /**
     * Sets if the wire between the origin and the corner is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== false;
      this._targetVisible = value;

      this._targetDot.setVisible(this._visible && this._targetVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "originWireVisible",
    get:
    /**
     * Gets if the wire between the origin and the corner is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._originWireVisible;
    }
    /**
     * Sets if the wire between the target and the corner is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== false;
      this._originWireVisible = value;

      this._originWire.setVisible(this._visible && this._originWireVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "targetWireVisible",
    get:
    /**
     * Gets if the wire between the target and the corner is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._targetWireVisible;
    }
    /**
     * Sets if the angle label is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== false;
      this._targetWireVisible = value;

      this._targetWire.setVisible(this._visible && this._targetWireVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "angleVisible",
    get:
    /**
     * Gets if the angle label is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._angleVisible;
    }
    /**
     * Sets if the labels are visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== false;
      this._angleVisible = value;

      this._angleLabel.setVisible(this._visible && this._angleVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "labelsVisible",
    get:
    /**
     * Gets if the labels are visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._labelsVisible;
    }
    /**
     * Sets if this DistanceMeasurement appears highlighted.
     * @param highlighted
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultLabelsVisible;
      this._labelsVisible = value;
      var labelsVisible = this._visible && this._labelsVisible;

      this._angleLabel.setVisible(labelsVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "setHighlighted",
    value: function setHighlighted(highlighted) {
      this._originDot.setHighlighted(highlighted);

      this._cornerDot.setHighlighted(highlighted);

      this._targetDot.setHighlighted(highlighted);

      this._originWire.setHighlighted(highlighted);

      this._targetWire.setHighlighted(highlighted);

      this._angleLabel.setHighlighted(highlighted);
    }
    /**
     * Sets if the wires, dots ad labels will fire "mouseOver" "mouseLeave" and "contextMenu" events.
     *
     * @type {Boolean}
     */

  }, {
    key: "clickable",
    get:
    /**
     * Gets if the wires, dots ad labels will fire "mouseOver" "mouseLeave" and "contextMenu" events.
     *
     * @type {Boolean}
     */
    function get() {
      return this._clickable;
    }
    /**
     * @private
     */
    ,
    set: function set(value) {
      value = !!value;
      this._clickable = value;

      this._originDot.setClickable(this._clickable);

      this._cornerDot.setClickable(this._clickable);

      this._targetDot.setClickable(this._clickable);

      this._originWire.setClickable(this._clickable);

      this._targetWire.setClickable(this._clickable);

      this._angleLabel.setClickable(this._clickable);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var scene = this.plugin.viewer.scene;

      if (this._onViewMatrix) {
        scene.camera.off(this._onViewMatrix);
      }

      if (this._onProjMatrix) {
        scene.camera.off(this._onProjMatrix);
      }

      if (this._onCanvasBoundary) {
        scene.canvas.off(this._onCanvasBoundary);
      }

      this._originDot.destroy();

      this._cornerDot.destroy();

      this._targetDot.destroy();

      this._originWire.destroy();

      this._targetWire.destroy();

      this._angleLabel.destroy();

      _get(_getPrototypeOf(AngleMeasurement.prototype), "destroy", this).call(this);
    }
  }]);

  return AngleMeasurement;
}(Component);

function _createSuper$1(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$1(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var FINDING_ORIGIN = 0;
var FINDING_CORNER = 1;
var FINDING_TARGET = 2;
/**
 * Creates {@link AngleMeasurement}s from mouse and touch input.
 *
 * Belongs to a {@link AngleMeasurementsPlugin}. Located at {@link AngleMeasurementsPlugin#control}.
 *
 * Once the AngleMeasurementControl is activated, the first click on any {@link Entity} begins constructing a {@link AngleMeasurement}, fixing its origin to that Entity. The next click on any Entity will complete the AngleMeasurement, fixing its target to that second Entity. The AngleMeasurementControl will then wait for the next click on any Entity, to begin constructing another AngleMeasurement, and so on, until deactivated.
 *
 * See {@link AngleMeasurementsPlugin} for more info.
 */

var AngleMeasurementsControl = /*#__PURE__*/function (_Component) {
  _inherits(AngleMeasurementsControl, _Component);

  var _super = _createSuper$1(AngleMeasurementsControl);

  /**
   * @private
   */
  function AngleMeasurementsControl(plugin) {
    var _this;

    _classCallCheck(this, AngleMeasurementsControl);

    _this = _super.call(this, plugin.viewer.scene);
    /**
     * The {@link AngleMeasurementsPlugin} that owns this AngleMeasurementsControl.
     * @type {AngleMeasurementsPlugin}
     */

    _this.plugin = plugin;
    _this._active = false;
    _this._state = FINDING_ORIGIN;
    _this._currentAngleMeasurement = null; // Event handles from CameraControl

    _this._onMouseHoverSurface = null;
    _this._onHoverNothing = null;
    _this._onMouseHoverOff = null;
    _this._onPickedNothing = null;
    _this._onPickedSurface = null; // Event handles from Scene.input

    _this._onInputMouseDown = null;
    _this._onInputMouseUp = null; // Event handles from Canvas element

    _this._onCanvasTouchStart = null;
    _this._onCanvasTouchEnd = null;
    return _this;
  }
  /** Gets if this AngleMeasurementsControl is currently active, where it is responding to input.
   *
   * @returns {Boolean}
   */


  _createClass(AngleMeasurementsControl, [{
    key: "active",
    get: function get() {
      return this._active;
    }
    /**
     * Activates this AngleMeasurementsControl, ready to respond to input.
     */

  }, {
    key: "activate",
    value: function activate() {
      var _this2 = this;

      if (this._active) {
        return;
      }

      var plugin = this.plugin;
      var scene = this.scene;
      var cameraControl = plugin.viewer.cameraControl;
      var canvas = scene.canvas.canvas;
      var input = scene.input;
      var pickSurfacePrecisionEnabled = scene.pickSurfacePrecisionEnabled;
      var isMouseHoveringEntity = false;
      var mouseHoverEntity = null;
      var mouseWorldPos = math.vec3();
      var mouseHoverCanvasPos = math.vec2();
      var lastMouseCanvasX;
      var lastMouseCanvasY;
      var mouseCanvasClickTolerance = 5;
      var touchCanvasClickTolerance = 5;
      var touchStartCanvasPos = math.vec2();
      var touchEndCanvasPos = math.vec2();
      math.vec3();
      this._onMouseHoverSurface = cameraControl.on("hoverSurface", function (event) {
        isMouseHoveringEntity = true;
        mouseHoverEntity = event.entity;
        mouseWorldPos.set(event.worldPos);
        mouseHoverCanvasPos.set(event.canvasPos);

        if (_this2._currentAngleMeasurement) {
          switch (_this2._state) {
            case FINDING_CORNER:
              _this2._currentAngleMeasurement.originWireVisible = true;
              _this2._currentAngleMeasurement.targetWireVisible = false;
              _this2._currentAngleMeasurement.cornerVisible = true;
              _this2._currentAngleMeasurement.angleVisible = false;
              _this2._currentAngleMeasurement.corner.entity = event.entity;
              _this2._currentAngleMeasurement.corner.worldPos = event.worldPos;
              canvas.style.cursor = "pointer";
              break;

            case FINDING_TARGET:
              _this2._currentAngleMeasurement.targetWireVisible = true;
              _this2._currentAngleMeasurement.targetVisible = true;
              _this2._currentAngleMeasurement.angleVisible = true;
              _this2._currentAngleMeasurement.target.entity = event.entity;
              _this2._currentAngleMeasurement.target.worldPos = event.worldPos;
              canvas.style.cursor = "pointer";
              break;
          }
        }
      });
      this._onInputMouseDown = input.on("mousedown", function (coords) {
        if (!input.mouseDownLeft) {
          lastMouseCanvasX = null;
          lastMouseCanvasY = null;
          return;
        }

        lastMouseCanvasX = coords[0];
        lastMouseCanvasY = coords[1];
      });
      this._onInputMouseUp = input.on("mouseup", function (coords) {
        if (!lastMouseCanvasX || !lastMouseCanvasY) {
          return;
        }

        if (coords[0] > lastMouseCanvasX + mouseCanvasClickTolerance || coords[0] < lastMouseCanvasX - mouseCanvasClickTolerance || coords[1] > lastMouseCanvasY + mouseCanvasClickTolerance || coords[1] < lastMouseCanvasY - mouseCanvasClickTolerance) {
          return;
        }

        switch (_this2._state) {
          case FINDING_ORIGIN:
            if (isMouseHoveringEntity) {
              if (pickSurfacePrecisionEnabled) {
                var pickResult = scene.pick({
                  canvasPos: mouseHoverCanvasPos,
                  pickSurface: true,
                  pickSurfacePrecision: pickSurfacePrecisionEnabled
                });

                if (pickResult && pickResult.worldPos) {
                  worldPos.set(pickResult.worldPos);
                }
              }

              _this2._currentAngleMeasurement = _this2.plugin.createMeasurement({
                id: math.createUUID(),
                origin: {
                  entity: mouseHoverEntity,
                  worldPos: mouseWorldPos
                },
                corner: {
                  entity: mouseHoverEntity,
                  worldPos: mouseWorldPos
                },
                target: {
                  entity: mouseHoverEntity,
                  worldPos: mouseWorldPos
                },
                approximate: true
              });
              _this2._currentAngleMeasurement.originVisible = true;
              _this2._currentAngleMeasurement.originWireVisible = true;
              _this2._currentAngleMeasurement.cornerVisible = false;
              _this2._currentAngleMeasurement.targetWireVisible = false;
              _this2._currentAngleMeasurement.targetVisible = false;
              _this2._currentAngleMeasurement.angleVisible = false;
              _this2._currentAngleMeasurement.clickable = false;
              _this2._state = FINDING_CORNER;

              _this2.fire("measurementStart", _this2._currentAngleMeasurement);
            }

            break;

          case FINDING_CORNER:
            if (isMouseHoveringEntity) {
              if (pickSurfacePrecisionEnabled) {
                var _pickResult = scene.pick({
                  canvasPos: mouseHoverCanvasPos,
                  pickSurface: true,
                  pickSurfacePrecision: true
                });

                if (_pickResult && _pickResult.worldPos) {
                  _this2._currentAngleMeasurement.corner.worldPos = _pickResult.worldPos;
                }
              }

              _this2._currentAngleMeasurement.targetWireVisible = false;
              _this2._currentAngleMeasurement.targetVisible = true;
              _this2._currentAngleMeasurement.angleVisible = true;
              _this2._state = FINDING_TARGET;
            } else {
              if (_this2._currentAngleMeasurement) {
                _this2._currentAngleMeasurement.destroy();

                _this2._currentAngleMeasurement = null;
                _this2._state = FINDING_ORIGIN;

                _this2.fire("measurementCancel", _this2._currentAngleMeasurement);
              }
            }

            break;

          case FINDING_TARGET:
            if (isMouseHoveringEntity) {
              if (pickSurfacePrecisionEnabled) {
                var _pickResult2 = scene.pick({
                  canvasPos: mouseHoverCanvasPos,
                  pickSurface: true,
                  pickSurfacePrecision: true
                });

                if (_pickResult2 && _pickResult2.worldPos) {
                  _this2._currentAngleMeasurement.target.worldPos = _pickResult2.worldPos;
                  _this2._currentAngleMeasurement.approximate = false;
                }
              }

              _this2._currentAngleMeasurement.targetVisible = true;
              _this2._currentAngleMeasurement.angleVisible = true;
              _this2._currentAngleMeasurement.clickable = true;

              _this2.fire("measurementEnd", _this2._currentAngleMeasurement);

              _this2._currentAngleMeasurement = null;
              _this2._state = FINDING_ORIGIN;
            } else {
              if (_this2._currentAngleMeasurement) {
                _this2._currentAngleMeasurement.destroy();

                _this2._currentAngleMeasurement = null;
                _this2._state = FINDING_ORIGIN;

                _this2.fire("measurementCancel", _this2._currentAngleMeasurement);
              }
            }

            break;
        }
      });
      this._onHoverNothing = cameraControl.on("hoverOff", function (event) {
        isMouseHoveringEntity = false;

        if (_this2._currentAngleMeasurement) {
          switch (_this2._state) {
            case FINDING_ORIGIN:
              _this2._currentAngleMeasurement.originVisible = false;
              break;

            case FINDING_CORNER:
              _this2._currentAngleMeasurement.cornerVisible = false;
              _this2._currentAngleMeasurement.originWireVisible = false;
              _this2._currentAngleMeasurement.targetVisible = false;
              _this2._currentAngleMeasurement.targetWireVisible = false;
              _this2._currentAngleMeasurement.angleVisible = false;
              break;

            case FINDING_TARGET:
              _this2._currentAngleMeasurement.targetVisible = false;
              _this2._currentAngleMeasurement.targetWireVisible = false;
              _this2._currentAngleMeasurement.angleVisible = false;
              break;
          }

          canvas.style.cursor = "default";
        }
      });
      canvas.addEventListener("touchstart", this._onCanvasTouchStart = function (event) {
        var touches = event.touches;
        var changedTouches = event.changedTouches;

        if (touches.length === 1 && changedTouches.length === 1) {
          getCanvasPosFromEvent(touches[0], touchStartCanvasPos);
        }
      }, {
        passive: true
      });
      canvas.addEventListener("touchend", this._onCanvasTouchEnd = function (event) {
        var touches = event.touches;
        var changedTouches = event.changedTouches;

        if (touches.length === 0 && changedTouches.length === 1) {
          getCanvasPosFromEvent(changedTouches[0], touchEndCanvasPos);

          if (touchEndCanvasPos[0] > touchStartCanvasPos[0] + touchCanvasClickTolerance || touchEndCanvasPos[0] < touchStartCanvasPos[0] - touchCanvasClickTolerance || touchEndCanvasPos[1] > touchStartCanvasPos[1] + touchCanvasClickTolerance || touchEndCanvasPos[1] < touchStartCanvasPos[1] - touchCanvasClickTolerance) {
            return; // User is repositioning the camera or model
          }

          var pickResult = scene.pick({
            canvasPos: touchEndCanvasPos,
            pickSurface: true,
            pickSurfacePrecision: false
          });

          if (pickResult && pickResult.worldPos) {
            switch (_this2._state) {
              case FINDING_ORIGIN:
                _this2._currentAngleMeasurement = _this2.plugin.createMeasurement({
                  id: math.createUUID(),
                  origin: {
                    entity: pickResult.entity,
                    worldPos: pickResult.worldPos
                  },
                  corner: {
                    entity: pickResult.entity,
                    worldPos: pickResult.worldPos
                  },
                  target: {
                    entity: pickResult.entity,
                    worldPos: pickResult.worldPos
                  },
                  approximate: true
                });
                _this2._currentAngleMeasurement.originVisible = true;
                _this2._currentAngleMeasurement.originWireVisible = true;
                _this2._currentAngleMeasurement.cornerVisible = false;
                _this2._currentAngleMeasurement.targetWireVisible = false;
                _this2._currentAngleMeasurement.targetVisible = false;
                _this2._currentAngleMeasurement.angleVisible = false;
                _this2._currentAngleMeasurement.clickable = false;
                _this2._state = FINDING_CORNER;

                _this2.fire("measurementStart", _this2._currentAngleMeasurement);

                break;

              case FINDING_CORNER:
                _this2._currentAngleMeasurement.corner.worldPos = pickResult.worldPos;
                _this2._currentAngleMeasurement.targetWireVisible = false;
                _this2._currentAngleMeasurement.targetVisible = true;
                _this2._currentAngleMeasurement.angleVisible = true;
                _this2._state = FINDING_TARGET;
                break;

              case FINDING_TARGET:
                _this2._currentAngleMeasurement.target.worldPos = pickResult.worldPos; //  this._currentAngleMeasurement.approximate = false;

                _this2._currentAngleMeasurement.targetVisible = true;
                _this2._currentAngleMeasurement.angleVisible = true;
                _this2._currentAngleMeasurement.clickable = true;

                _this2.fire("measurementEnd", _this2._currentAngleMeasurement);

                _this2._currentAngleMeasurement = null;
                _this2._state = FINDING_ORIGIN;
                break;
            }
          } else {
            if (_this2._currentAngleMeasurement) {
              _this2._currentAngleMeasurement.destroy();

              _this2._currentAngleMeasurement = null;
              _this2._state = FINDING_ORIGIN;

              _this2.fire("measurementCancel", _this2._currentAngleMeasurement);
            }
          }
        } //  event.stopPropagation();

      }, {
        passive: true
      });
      this._active = true;
    }
    /**
     * Deactivates this AngleMeasurementsControl, making it unresponsive to input.
     *
     * Destroys any {@link AngleMeasurement} under construction.
     */

  }, {
    key: "deactivate",
    value: function deactivate() {
      if (!this._active) {
        return;
      }

      this.reset();
      var input = this.plugin.viewer.scene.input;
      var cameraControl = this.plugin.viewer.cameraControl;
      var canvas = this.plugin.viewer.scene.canvas.canvas;
      input.off(this._onInputMouseDown);
      input.off(this._onInputMouseUp);
      cameraControl.off(this._onMouseHoverSurface);
      cameraControl.off(this._onPickedSurface);
      cameraControl.off(this._onHoverNothing);
      cameraControl.off(this._onPickedNothing);
      canvas.removeEventListener("touchstart", this._onCanvasTouchStart);
      canvas.removeEventListener("touchend", this._onCanvasTouchEnd);
      this._currentAngleMeasurement = null;
      this._active = false;
    }
    /**
     * Resets this AngleMeasurementsControl.
     *
     * Destroys any {@link AngleMeasurement} under construction.
     *
     * Does nothing if the AngleMeasurementsControl is not active.
     */

  }, {
    key: "reset",
    value: function reset() {
      if (!this._active) {
        return;
      }

      if (this._currentAngleMeasurement) {
        this._currentAngleMeasurement.destroy();

        this._currentAngleMeasurement = null;
      }

      this._state = FINDING_ORIGIN;
    }
    /**
     * @private
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this.deactivate();

      _get(_getPrototypeOf(AngleMeasurementsControl.prototype), "destroy", this).call(this);
    }
  }]);

  return AngleMeasurementsControl;
}(Component);

var getCanvasPosFromEvent = function getCanvasPosFromEvent(event, canvasPos) {
  if (!event) {
    event = window.event;
    canvasPos[0] = event.x;
    canvasPos[1] = event.y;
  } else {
    var element = event.target;
    var totalOffsetLeft = 0;
    var totalOffsetTop = 0;

    while (element.offsetParent) {
      totalOffsetLeft += element.offsetLeft;
      totalOffsetTop += element.offsetTop;
      element = element.offsetParent;
    }

    canvasPos[0] = event.pageX - totalOffsetLeft;
    canvasPos[1] = event.pageY - totalOffsetTop;
  }

  return canvasPos;
};

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
/**
 * {@link Viewer} plugin for measuring angles.
 *
 * [<img src="https://user-images.githubusercontent.com/83100/63641903-61488180-c6b6-11e9-8e00-895b9d16dc4b.gif">](https://xeokit.github.io/xeokit-sdk/examples/#measurements_angle_createWithMouse)
 *
 * * [[Example 1: Model with angle measurements](https://xeokit.github.io/xeokit-sdk/examples/#measurements_angle_modelWithMeasurements)]
 * * [[Example 2: Create angle measurements with mouse](https://xeokit.github.io/xeokit-sdk/examples/#measurements_angle_createWithMouse)]
 *
 * ## Overview
 *
 * * An {@link AngleMeasurement} shows the angle between two connected 3D line segments, given
 * as three positions on the surface(s) of one or more {@link Entity}s.
 * * As shown on the screen capture above, a AngleMeasurement has two wires that show the line segments, with a label that shows the angle between them.
 * * Create AngleMeasurements programmatically with {@link AngleMeasurementsPlugin#createMeasurement}.
 * * Create AngleMeasurements interactively using the {@link AngleMeasurementsControl}, located at {@link AngleMeasurementsPlugin#control}.
 * * Existing AngleMeasurements are registered by ID in {@link AngleMeasurementsPlugin#measurements}.
 * * Destroy AngleMeasurements using {@link AngleMeasurementsPlugin#destroyMeasurement}.
 * * Configure global measurement units and scale via {@link Metrics}, located at {@link Scene#metrics}
 *
 * ## Example 1: Creating AngleMeasurements Programmatically
 *
 * In our first example, we'll use an {@link XKTLoaderPlugin} to load a model, and then use a AngleMeasurementsPlugin to programmatically create two {@link AngleMeasurement}s.
 *
 * Note how each AngleMeasurement has ````origin````, ````corner```` and  ````target````, which each indicate a 3D World-space
 * position on the surface of an {@link Entity}. These can be aon the same Entity, or on different Entitys.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_angle_modelWithMeasurements)]
 *
 * ````JavaScript
 * import {Viewer, XKTLoaderPlugin, AngleMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const angleMeasurements = new AngleMeasurementsPlugin(viewer);
 *
 * const model = xktLoader.load({
 *      src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * model.on("loaded", () => {
 *
 *      const myMeasurement1 = angleMeasurements.createMeasurement({
 *          id: "myAngleMeasurement1",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [0.044, 5.998, 17.767]
 *          },
 *          corner: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [0.044, 5.998, 17.767]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [4.738, 3.172, 17.768]
 *          },
 *          visible: true
 *      });
 *
 *      const myMeasurement2 = angleMeasurements.createMeasurement({
 *          id: "myAngleMeasurement2",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FNr2"],
 *              worldPos: [0.457, 2.532, 17.766]
 *          },
 *          corner: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FNr2"],
 *              worldPos: [0.457, 2.532, 17.766]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["1CZILmCaHETO8tf3SgGEXu"],
 *              worldPos: [0.436, 0.001, 22.135]
 *          },
 *          visible: true
 *      });
 * });
 * ````
 *
 * ## Example 2: Creating AngleMeasurements Interactively
 *
 * In our second example, we'll use an {@link XKTLoaderPlugin} to load a model, then we'll use the AngleMeasurementsPlugin's {@link AngleMeasurementsControl} to interactively create {@link AngleMeasurement}s with mouse or touch input.
 *
 * After we've activated the AngleMeasurementsControl, the first click on any {@link Entity} begins constructing a AngleMeasurement, fixing its
 * origin to that Entity. The next click on any Entity will fix the AngleMeasurement's corner, and the next click after
 * that will fix its target and complete the AngleMeasurement.
 *
 * The AngleMeasurementControl will then wait for the next click on any Entity, to begin constructing
 * another AngleMeasurement, and so on, until deactivated again.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_angle_createWithMouse)]
 *
 * ````JavaScript
 * import {Viewer, XKTLoaderPlugin, AngleMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const angleMeasurements = new AngleMeasurementsPlugin(viewer);
 *
 * const model = xktLoader.load({
 *     src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * angleMeasurements.control.activate();  // <------------ Activate the AngleMeasurementsControl
 * ````
 *
 * ## Example 4: Attaching Mouse Handlers
 *
 * In our fourth example, we'll attach even handlers to our plugin, to catch when the user
 * hovers or right-clicks over our measurements.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_angle_modelWithMeasurements)]
 *
 * ````javascript
 * import {Viewer, XKTLoaderPlugin, AngleMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const angleMeasurements = new AngleMeasurementsPlugin(viewer);
 *
 * angleMeasurements.on("mouseOver", (e) => {
 *     e.measurement.setHighlighted(true);
 * });
 *
 * angleMeasurements.on("mouseLeave", (e) => {
 *     e.measurement.setHighlighted(false);
 * });
 *
 * angleMeasurements.on("contextMenu", (e) => {
 *     // Show context menu
 *     e.event.preventDefault();
 * });
 *
 * const model = xktLoader.load({
 *      src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * model.on("loaded", () => {
 *
 *       angleMeasurementsPlugin.createMeasurement({
 *             id: "angleMeasurement1",
 *             origin: {
 *                 entity: viewer.scene.objects["1CZILmCaHETO8tf3SgGEXu"],
 *                 worldPos: [0.4158603637281142, 2.5193106917110457, 17.79972838299403]
 *             },
 *             corner: {
 *                 entity: viewer.scene.objects["1CZILmCaHETO8tf3SgGEXu"],
 *                 worldPos: [0.41857741956197625,0.0987169929481646,17.799763071093395]
 *             },
 *             target: {
 *                 entity: viewer.scene.objects["1CZILmCaHETO8tf3SgGEXu"],
 *                 worldPos: [5.235526066859247, 0.11580773869801986, 17.824891550941565]
 *             },
 *             visible: true
 *         });
 *
 *         angleMeasurementsPlugin.createMeasurement({
 *             id: "angleMeasurement2",
 *             origin: {
 *                 entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FNr2"],
 *                 worldPos: [-0.00003814187850181838, 5.9996748076205115,17.79996871551525]
 *             },
 *             corner: {
 *                 entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FNqI"],
 *                 worldPos: [-0.0005214119318139865, 3.1010044228517595, 17.787656604483363]
 *
 *             },
 *             target: {
 *                 entity: viewer.scene.objects["1s1jVhK8z0pgKYcr9jt7AB"],
 *                 worldPos: [ 8.380657312957396, 3.1055697628459553, 17.799220108187185]
 *             },
 *             visible: true
 *         });
 * });
 * ````
 */

var AngleMeasurementsPlugin = /*#__PURE__*/function (_Plugin) {
  _inherits(AngleMeasurementsPlugin, _Plugin);

  var _super = _createSuper(AngleMeasurementsPlugin);

  /**
   * @constructor
   * @param {Viewer} viewer The Viewer.
   * @param {Object} [cfg]  Plugin configuration.
   * @param {String} [cfg.id="AngleMeasurements"] Optional ID for this plugin, so that we can find it within {@link Viewer#plugins}.
   * @param {HTMLElement} [cfg.container] Container DOM element for markers and labels. Defaults to ````document.body````.
   * @param {string} [cfg.defaultColor=null] The default color of the dots, wire and label.
  * @param {boolean} [cfg.defaultLabelsVisible=true] The default value of {@link AngleMeasurement.labelsVisible}.
   * @param {number} [cfg.zIndex] If set, the wires, dots and labels will have this zIndex (+1 for dots and +2 for labels).
  */
  function AngleMeasurementsPlugin(viewer) {
    var _this;

    var cfg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, AngleMeasurementsPlugin);

    _this = _super.call(this, "AngleMeasurements", viewer);
    _this._container = cfg.container || document.body;
    _this._control = new AngleMeasurementsControl(_assertThisInitialized(_this));
    _this._measurements = {};
    _this.defaultColor = cfg.defaultColor !== undefined ? cfg.defaultColor : "#00BBFF";
    _this.defaultLabelsVisible = cfg.defaultLabelsVisible !== false;
    _this.zIndex = cfg.zIndex || 10000;

    _this._onMouseOver = function (event, measurement) {
      _this.fire("mouseOver", {
        plugin: _assertThisInitialized(_this),
        measurement: measurement,
        event: event
      });
    };

    _this._onMouseLeave = function (event, measurement) {
      _this.fire("mouseLeave", {
        plugin: _assertThisInitialized(_this),
        measurement: measurement,
        event: event
      });
    };

    _this._onContextMenu = function (event, measurement) {
      _this.fire("contextMenu", {
        plugin: _assertThisInitialized(_this),
        measurement: measurement,
        event: event
      });
    };

    return _this;
  }
  /**
   * @private
   */


  _createClass(AngleMeasurementsPlugin, [{
    key: "send",
    value: function send(name, value) {}
    /**
     * Gets the {@link AngleMeasurementsControl}, which creates {@link AngleMeasurement}s from user input.
     *
     * @type {AngleMeasurementsControl}
     */

  }, {
    key: "control",
    get: function get() {
      return this._control;
    }
    /**
     * Gets the existing {@link AngleMeasurement}s, each mapped to its {@link AngleMeasurement#id}.
     *
     * @type {{String:AngleMeasurement}}
     */

  }, {
    key: "measurements",
    get: function get() {
      return this._measurements;
    }
    /**
     * Creates an {@link AngleMeasurement}.
     *
     * The AngleMeasurement is then registered by {@link AngleMeasurement#id} in {@link AngleMeasurementsPlugin#measurements}.
     *
     * @param {Object} params {@link AngleMeasurement} configuration.
     * @param {String} params.id Unique ID to assign to {@link AngleMeasurement#id}. The AngleMeasurement will be registered by this in {@link AngleMeasurementsPlugin#measurements} and {@link Scene.components}. Must be unique among all components in the {@link Viewer}.
     * @param {Number[]} params.origin.worldPos Origin World-space 3D position.
     * @param {Entity} params.origin.entity Origin Entity.
     * @param {Number[]} params.corner.worldPos Corner World-space 3D position.
     * @param {Entity} params.corner.entity Corner Entity.
     * @param {Number[]} params.target.worldPos Target World-space 3D position.
     * @param {Entity} params.target.entity Target Entity.
     * @param {Boolean} [params.visible=true] Whether to initially show the {@link AngleMeasurement}.
     * @returns {AngleMeasurement} The new {@link AngleMeasurement}.
     */

  }, {
    key: "createMeasurement",
    value: function createMeasurement() {
      var _this2 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (this.viewer.scene.components[params.id]) {
        this.error("Viewer scene component with this ID already exists: " + params.id);
        delete params.id;
      }

      var origin = params.origin;
      var corner = params.corner;
      var target = params.target;
      var measurement = new AngleMeasurement(this, {
        id: params.id,
        plugin: this,
        container: this._container,
        origin: {
          entity: origin.entity,
          worldPos: origin.worldPos
        },
        corner: {
          entity: corner.entity,
          worldPos: corner.worldPos
        },
        target: {
          entity: target.entity,
          worldPos: target.worldPos
        },
        visible: params.visible,
        originVisible: true,
        originWireVisible: true,
        cornerVisible: true,
        targetWireVisible: true,
        targetVisible: true,
        onMouseOver: this._onMouseOver,
        onMouseLeave: this._onMouseLeave,
        onContextMenu: this._onContextMenu
      });
      this._measurements[measurement.id] = measurement;
      measurement.on("destroyed", function () {
        delete _this2._measurements[measurement.id];
      });
      this.fire("measurementCreated", measurement);
      return measurement;
    }
    /**
     * Destroys a {@link AngleMeasurement}.
     *
     * @param {String} id ID of AngleMeasurement to destroy.
     */

  }, {
    key: "destroyMeasurement",
    value: function destroyMeasurement(id) {
      var measurement = this._measurements[id];

      if (!measurement) {
        this.log("AngleMeasurement not found: " + id);
        return;
      }

      measurement.destroy();
      this.fire("measurementDestroyed", measurement);
    }
    /**
     * Shows all or hides the angle label of each {@link AngleMeasurement}.
     *
     * @param {Boolean} labelsShown Whether or not to show the labels.
     */

  }, {
    key: "setLabelsShown",
    value: function setLabelsShown(labelsShown) {
      for (var _i = 0, _Object$entries = Object.entries(this.measurements); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2);
            _Object$entries$_i[0];
            var measurement = _Object$entries$_i[1];

        measurement.labelShown = labelsShown;
      }
    }
    /**
     * Destroys all {@link AngleMeasurement}s.
     */

  }, {
    key: "clear",
    value: function clear() {
      var ids = Object.keys(this._measurements);

      for (var i = 0, len = ids.length; i < len; i++) {
        this.destroyMeasurement(ids[i]);
      }
    }
    /**
     * Destroys this AngleMeasurementsPlugin.
     *
     * Destroys all {@link AngleMeasurement}s first.
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this.clear();

      _get(_getPrototypeOf(AngleMeasurementsPlugin.prototype), "destroy", this).call(this);
    }
  }]);

  return AngleMeasurementsPlugin;
}(Plugin);

export { AngleMeasurementsPlugin };
//# sourceMappingURL=angle-measurements.es.js.map
